'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _BaseModule = require('./BaseModule');

var _COLORS = require('./COLORS');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 把一些错认为名词的词标注为形容词，或者对名词作定语的情况
let AdjectiveOptimizer = function (_Optimizer) {
  (0, _inherits3.default)(AdjectiveOptimizer, _Optimizer);

  function AdjectiveOptimizer() {
    (0, _classCallCheck3.default)(this, AdjectiveOptimizer);
    return (0, _possibleConstructorReturn3.default)(this, (AdjectiveOptimizer.__proto__ || Object.getPrototypeOf(AdjectiveOptimizer)).apply(this, arguments));
  }

  (0, _createClass3.default)(AdjectiveOptimizer, [{
    key: 'doOptimize',
    value: function doOptimize(words) {
      const { POSTAG } = this.segment;
      let index = 0;
      while (index < words.length) {
        const word = words[index];
        const nextword = words[index + 1];
        if (nextword) {
          // 对于<颜色>+<的>，直接判断颜色是形容词（字典里颜色都是名词）
          if (nextword.p === POSTAG.D_U && _COLORS.colors.includes(word.w)) {
            word.p = POSTAG.D_A;
          }
          // 如果是连续的两个名词，前一个是颜色，那这个颜色也是形容词
          if (word.p === POSTAG.D_N && nextword.p === POSTAG.D_N && _COLORS.colors.includes(word.w)) {
            word.p = POSTAG.D_A;
          }
        }
        // 移到下一个单词
        index += 1;
      }
      return words;
    }
  }]);
  return AdjectiveOptimizer;
}(_BaseModule.Optimizer);

exports.default = AdjectiveOptimizer;